/*	
 *	clipmac.h
 *
 *	P/ECE USB Ethernet MACw
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Thu Aug 18 20:36:00 JST 2005 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __CLIP_MAC_H__
#define __CLIP_MAC_H__

/*****************************************************************************
 *	
 *****************************************************************************/

/*  ==========================[ Ethernetڰэ\ ]==========================
 *
 *           |<----- NDIS߰ײނ (60-1514 byte) ----->|
 *           |                                                       |
 *  +--------+--------------+--------------+--------+----------------+-----+
 *  | 8 byte |    6 byte    |    6 byte    | 2 byte |  46-1500 byte  |4byte|
 *  +--------+--------------+--------------+--------+----------------+-----+
 *  |ر|ĐMACڽ|MMACڽ|ڰ|      ް      | FCS |
 *  +--------+--------------+--------------+--------+----------------+-----+
 *       A                                                              A
 *       |                                                              |
 *       +-- NICʰ޳t/̂Ťײ޿ĳł͍lȂ --+
 */

/****************************************************************************
 *	
 ****************************************************************************/

#define MAC_PRODUCT_ID	(PCE_PRODUCT_ID+0x16)	/* d֎~!! */

/* MACu[hLXgAhX(FF-FF-FF-FF-FF-FF) */
extern const unsigned char mac_broadcast_address[6];

/****************************************************************************
 *	
 ****************************************************************************/

/* USB Ethernet MACwJn܂B
 * [in]
 *	rxque_capacity	ML[TCYB
 *	txque_capacity	ML[TCYB
 *	rxdone		MR[obNB(NULL:)
 *	txdone		MR[obNB(NULL:)
 * [note]
 *	* mac_open()ĂяoAvP[V́AIOɕKmac_close()ĂяoĂB
 *	  mac_close()ĂяoɃAvP[VIƁAVXeُN܂B
 *	* ML[TCYɕKvTCYw肵ꍇAKvTCY֐؂グĊmۂ܂B
 *	  ML[TCYɕKvTCYw肵ꍇAKvTCY֐؂グĊmۂ܂B
 *	* TODO: MR[obN̐ƁB
 *	* TODO: MR[obN̐ƁB
 */
void mac_open(int rxque_capacity, int txque_capacity, void (*rxdone)(), void (*txdone)());

/* USB Ethernet MACwؒf܂B
 * [note]
 *	* mac_close()́AɈSɌĂяoƂł܂B
 *	  mac_open()ĂяoĂȂĂAmac_close()Ăяoč\܂B
 */
void mac_close();

/* MpPbg擾܂B
 * [in]
 *	packet		擾pPbgi[obt@B
 *	maxlength	obt@̋eʁB
 * [out]
 *	߂l		Ȃ΁A擾pPbg̃oCgԂ܂B(60`1514)
 *			MpPbgAobt@̋eʕsȂ΁AԂ܂B
 */
int mac_recv(void* packet/*[maxlength]*/, int maxlength);

/* MpPbgǉ܂B
 * [in]
 *	packet		MpPbgB
 *	length		MpPbg̃TCYB(0`1514)
 * [out]
 *	߂l		Ȃ΁AMpPbgTCŶ܂ܕԂ܂B(length)
 *			ML[ꂽAԂ܂B
 * [note]
 *	* MpPbgTCY60w肵ꍇA60oCg܂ŃpfBOđo܂B
 *	  ́AEthernet̎dlłB
 */
int mac_send(const void* packet/*[length]*/, int length);

/* MACAhX擾܂B
 * [in]
 *	address		MACAhXi[6oCg̃obt@B
 * [note]
 *	* MACAhX́AzXg̃x_NGXgɂāAIɐݒ肳܂B
 *	- mac_open()̌AzXgfoCXoāAfoCXhCo[hA
 *	  x_NGXgɂMACAhXݒ肷܂łɁA^CO܂B
 *	  mac_open()͂܂AMACAhXݒ肳ĂȂƂɒӂĂB
 *	- mac_open()Ԃ̂܂P/ECE𔲂ƁAfoCXhCo[hA
 *	  x_NGXgɂĐVMACAhXݒ肳܂B
 *	  MACAhX́ACӂ̃^C~OōĐݒ肳\ƍlĂB
 */
void mac_address(void* address/*[6]*/);

/* USB Ethernet MACw̏Ԃ擾܂B
 * [in]
 *	stat		ʂi[MACSTAT\̂ւ̃|C^B
 */
typedef struct _MACSTAT {
	int rxok;	// MpPbg
	int rxerr;	// MG[̃pPbg
	int rxovr;	// MI[o[̃pPbg
	int txok;	// MpPbg
	int txerr;	// MG[̃pPbg (2005/08/19݁Agp)
	int txovr;	// MI[o[̃pPbg
} MACSTAT;
void mac_stat(MACSTAT* stat);

#endif /*__CLIP_MAC_H__*/
