/*
 *	main.c
 *
 *	USB-LAN(ping)
 *
 *	* Thu Aug 18 21:27:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	
 ****************************************************************************/

#define DEF_IPADDR	((192<<24)|(168<<16)|(255<<8)|1)
#define SAVE_FNAME	"usblan.sav"

static int
load_ip_addr()
{
	int ip_addr = DEF_IPADDR;
	//
	int retval;
	int data;
	FILE* fp;

	fp = fopen(SAVE_FNAME, "rb");
	if(fp) {
		retval = fread(&data, sizeof(int), 1, fp);
		if(retval == 1) {
			ip_addr = data;
		}
		fclose(fp);
	}

	return ip_addr;
}

static void
save_ip_addr(int ip_addr)
{
	int retval;
	FILEACC fa;

	if(load_ip_addr() == ip_addr) {
		return;
	}

	retval = pceFileCreate(SAVE_FNAME, sizeof(int));
	if(retval == 0) {
		retval = pceFileOpen(&fa, SAVE_FNAME, FOMD_WR);
		if(retval == 0) {
			pceFileWriteSct(&fa, &ip_addr, 0, 4);
			pceFileClose(&fa);
		}
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int ip_addr;

	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();
	pcePadSetTrigMode(PP_MODE_SINGLE);

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* IPAhX[h܂B */
	ip_addr = load_ip_addr();
	PUT_BEWORD(ip_address, ip_addr);

	/* PCrunŎsꍇUSB̂߂ɁAxď܂B */
	delay(SEC(0.1));
	mac_open(0, 0, rxdone, NULL);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	int ip_addr;

	/* mɐؒf܂B */
	mac_close();

	/* IPAhXZ[u܂B */
	ip_addr = BEWORD(ip_address);
	save_ip_addr(ip_addr);
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned char rep[8]; /* I[gs[gJE^ */
	//
	int x;
	int y;

	/* ʍXVB */
	pceLCDTrans();

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}

	/* O[o^C}XVB */
	now++;
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	sel = 3;
	for(;;) {
		schedule();

		/* SELECT{^ŏIB */
		if(joy & TRG_SELECT) {
			break;
		}

		/* IPAhXIB */
		if((joy & TRG_LF) && (sel > 0)) {
			sel--;
		}
		if((joy & TRG_RI) && (sel < 3)) {
			sel++;
		}

		/* IPAhXB */
		if(joy & TRG_A) {
			ip_address[sel]++;
		}
		if(joy & TRG_B) {
			ip_address[sel]--;
		}

		/* J[\_ŃJE^XVB */
		if(joy & (PAD_A | PAD_B)) {
			blink = 0;
		} else {
			blink++;
		}

		/* ʕ\B */
		disp();
	}

}

/****************************************************************************
 *	disp
 ****************************************************************************/

void
disp()
{
	unsigned char ma[6];
	MACSTAT ms;
	int i;
	int x;
	int y;

	mac_address(ma);
	mac_stat(&ms);

	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x80);
	pceFontSetTxColor(0);
	pceFontSetBkColor(3);
	pceFontSetPos((DISP_X - 5 * 25) / 2, 0);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr("===== USB-LAN(ping) =====");
	x = 4;
	y = 10;
	render_rectangle_fill(&render, 0, y, DISP_X, 10, 1);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(x, y);
	pceFontPrintf("IPڽF");
	for(i = 0; i < 4; i++) {
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		if(i == sel) {
			if(blink % SEC(0.5) < SEC(0.3)) {
				pceFontSetTxColor(0);
				pceFontSetBkColor(2);
			}
		}
		pceFontPrintf("%3d", ip_address[i]);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		if(i != 3) {
			pceFontPrintf(".");
		}
	}
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	y += 11;
	pceFontSetPos(x, y);
	pceFontPrintf("MACڽF");
	pceFontSetPos(x + 53, y + 2);
	pceFontSetType(0x82);
	pceFontPrintf("%02x-%02x-%02x-%02x-%02x-%02x", ma[0],ma[1],ma[2],ma[3],ma[4],ma[5]);
	pceFontSetType(0x80);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("MpPbgF%8u", ms.rxok);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("M݉񐔁F%8u", ms.rxovr);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("MG[񐔁F%8u", ms.rxerr);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("MpPbgF%8u", ms.txok);
	y += 9;
	pceFontSetPos(x, y);
	pceFontPrintf("M݉񐔁F%8u", ms.txovr);
	pceFontSetTxColor(0);
	pceFontSetBkColor(2);
	pceFontSetPos((DISP_X - 10 * 13) / 2, DISP_Y - 10);
	/*             OPQRSTUVWXOPQ */
	pceFontPutStr(" SELECT{^ŏI܂ ");
	pceLCDTrans();
}

/****************************************************************************
 *	
 ****************************************************************************/

void
rxdone()
{
	unsigned char dst_mac[6];
	unsigned char src_mac[6];
	int llc_type;
	int dst_ip;
	int src_ip;
	int len;
	IPHEADER hdr;

	len = mac_recv(packet, sizeof packet);
	if(len < 14) {
		return;
	}
	memcpy(dst_mac, packet+0, 6);	/* Mn[hEFAAhX */
	memcpy(src_mac, packet+6, 6);	/* Mn[hEFAAhX or FF-FF-FF-FF-FF-FF */
	llc_type = BEHALF(packet+12);	/* LLCvgR^Cv */

	/* 炩߁AԐMpEthernetwb_ݒ肵Ă܂B */
	memcpy(packet+0, src_mac, 6);	/* Mn[hEFAAhX */
	mac_address(packet+6);		/* Mn[hEFAAhX */

	switch(llc_type) {
	case 0x0806: /* ARP */
		if(len < 14+28) {
			return;
		}
		if(BEHALF(packet+14+0) != 1) { /* n[hEFA^Cv */
			return;
		}
		if(BEBYTE(packet+14+4) != 6) { /* n[hEFAAhX */
			return;
		}
		if(BEBYTE(packet+14+5) != 4) { /* vgRAhX */
			return;
		}
		if(BEHALF(packet+14+6) != 1) { /* Iy[VR[h */
			return;
		}
		if(memcmp(packet+14+8, src_mac, 6) != 0) { /* Mn[hEFAAhX */
			return;
		}
		src_ip = BEWORD(packet+14+14); /* MvgRAhX */
		dst_ip = BEWORD(packet+14+24); /* MvgRAhX */
		if(dst_ip != BEWORD(ip_address)) {
			return;
		}

		/* ԐMpARPpPbgݒ肵܂B */
		PUT_BEHALF(packet+14+6, 2);		/* Iy[VR[h */
		mac_address(packet+14+8);		/* Mn[hEFAAhX */
		PUT_BEWORD(packet+14+14, dst_ip);	/* MvgRAhX */
		memcpy(packet+14+18, src_mac, 6);	/* Mn[hEFAAhX */
		PUT_BEWORD(packet+14+24, src_ip);	/* MvgRAhX */
		mac_send(packet, 14+28);

		return;

	case 0x800: /* IP */
		len = unpack_ip_header(&hdr, packet+14, len);
		if(len < 0) {
			return;
		}
		if(hdr.protocol != 1) { /* ICMP */
			return;
		}
		if(hdr.destination_ip_address != BEWORD(ip_address)) {
			return;
		}
		if(hdr.data_length < 4) { /* ICMP header */
			return;
		}
		if(internet_checksum(hdr.data, hdr.data_length) != 0) {
			return;
		}
		if(hdr.data[0] != 8) { /* ICMP echo request */
			return;
		}

		/* ԐMppingpPbgݒ肵܂B */
		XCHG(hdr.source_ip_address, hdr.destination_ip_address);
		hdr.data[0] = 0; /* ICMP echo reply */
		update_internet_checksum(hdr.data, hdr.data_length, 2);
		len = pack_ip_header(&hdr, packet+14, (sizeof packet)-14);
		if(len < 0) {
			return;
		}
		mac_send(packet, len+14);

		return;
	}
}

